"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../../basicR.type");
var class_validator_1 = require("class-validator");
var farm_type_1 = require("../../visit/farm.type");
var RoutineExpenseCategory;
(function (RoutineExpenseCategory) {
    RoutineExpenseCategory[RoutineExpenseCategory["RENT"] = 0] = "RENT";
    RoutineExpenseCategory[RoutineExpenseCategory["SOCIAL_EXPENSES"] = 1] = "SOCIAL_EXPENSES";
    RoutineExpenseCategory[RoutineExpenseCategory["ELECTRICITY"] = 2] = "ELECTRICITY";
    RoutineExpenseCategory[RoutineExpenseCategory["EMPLOYEE"] = 3] = "EMPLOYEE";
    RoutineExpenseCategory[RoutineExpenseCategory["PHONE"] = 4] = "PHONE";
    RoutineExpenseCategory[RoutineExpenseCategory["INTERNET"] = 5] = "INTERNET";
    // Ordem de produção - Milho Rehidratado
    // Ordem de produção - Silagem de Milho (Volumoso)
    // Ordem de produção - Manutenção de Pastagem (Volumoso)
})(RoutineExpenseCategory = exports.RoutineExpenseCategory || (exports.RoutineExpenseCategory = {}));
var RoutineExpenseKinship;
(function (RoutineExpenseKinship) {
    RoutineExpenseKinship[RoutineExpenseKinship["OWNER"] = 0] = "OWNER";
    RoutineExpenseKinship[RoutineExpenseKinship["FATHER"] = 1] = "FATHER";
    RoutineExpenseKinship[RoutineExpenseKinship["MOTHER"] = 2] = "MOTHER";
    RoutineExpenseKinship[RoutineExpenseKinship["SON"] = 3] = "SON";
    RoutineExpenseKinship[RoutineExpenseKinship["DAUGHTER"] = 4] = "DAUGHTER";
    RoutineExpenseKinship[RoutineExpenseKinship["UNCLE"] = 5] = "UNCLE";
    RoutineExpenseKinship[RoutineExpenseKinship["NEPHEW"] = 6] = "NEPHEW";
})(RoutineExpenseKinship = exports.RoutineExpenseKinship || (exports.RoutineExpenseKinship = {}));
var RoutineExpenseRole;
(function (RoutineExpenseRole) {
    RoutineExpenseRole[RoutineExpenseRole["TECHNICIAN"] = 0] = "TECHNICIAN";
    RoutineExpenseRole[RoutineExpenseRole["MANAGER"] = 1] = "MANAGER";
    RoutineExpenseRole[RoutineExpenseRole["HANDLER"] = 2] = "HANDLER";
})(RoutineExpenseRole = exports.RoutineExpenseRole || (exports.RoutineExpenseRole = {}));
var RoutineExpense = /** @class */ (function (_super) {
    __extends(RoutineExpense, _super);
    function RoutineExpense() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.ManyToOne(function (type) { return farm_type_1.Farm; }, { nullable: false }),
        __metadata("design:type", farm_type_1.Farm)
    ], RoutineExpense.prototype, "farm", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column(),
        class_validator_1.IsNumber(),
        __metadata("design:type", Number)
    ], RoutineExpense.prototype, "value", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.Column(),
        class_validator_1.IsString(),
        __metadata("design:type", String)
    ], RoutineExpense.prototype, "description", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.Column({ type: 'int' }),
        class_validator_1.IsNumber(),
        __metadata("design:type", Number)
    ], RoutineExpense.prototype, "kinship", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.Column({ type: 'int' }),
        class_validator_1.IsNumber(),
        __metadata("design:type", Number)
    ], RoutineExpense.prototype, "role", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ type: 'int' }),
        class_validator_1.IsNumber(),
        __metadata("design:type", Number)
    ], RoutineExpense.prototype, "category", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.Column(),
        class_validator_1.IsNumber(),
        __metadata("design:type", Number)
    ], RoutineExpense.prototype, "percentDedication", void 0);
    RoutineExpense = __decorate([
        typeorm_1.Entity()
    ], RoutineExpense);
    return RoutineExpense;
}(basicR_type_1.BasicREntity));
exports.RoutineExpense = RoutineExpense;
//# sourceMappingURL=routineExpense.type.js.map