"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var address_type_1 = require("../app/address.type");
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../basicR.type");
var class_validator_1 = require("class-validator");
var farmConsultant_type_1 = require("./farmConsultant.type");
var ConsultantEducation;
(function (ConsultantEducation) {
    ConsultantEducation[ConsultantEducation["VETERINARIAN"] = 0] = "VETERINARIAN";
    ConsultantEducation[ConsultantEducation["AGRONOMIST"] = 1] = "AGRONOMIST";
    ConsultantEducation[ConsultantEducation["ZOOTECHNIST"] = 2] = "ZOOTECHNIST";
    ConsultantEducation[ConsultantEducation["LIVESTOCK_TECHNICIAN"] = 3] = "LIVESTOCK_TECHNICIAN";
})(ConsultantEducation = exports.ConsultantEducation || (exports.ConsultantEducation = {}));
var UserConsultant = /** @class */ (function (_super) {
    __extends(UserConsultant, _super);
    function UserConsultant() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UserConsultant_1 = UserConsultant;
    var UserConsultant_1;
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], UserConsultant.prototype, "name", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], UserConsultant.prototype, "emails", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], UserConsultant.prototype, "linkPhoto", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], UserConsultant.prototype, "phones", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], UserConsultant.prototype, "identification", void 0);
    __decorate([
        typeorm_1.JoinColumn(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.OneToOne(function (type) { return address_type_1.Address; }, { cascade: true, nullable: false }),
        __metadata("design:type", address_type_1.Address)
    ], UserConsultant.prototype, "address", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false, type: 'int' }),
        __metadata("design:type", Number)
    ], UserConsultant.prototype, "consultantEducation", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToOne(function (type) { return UserConsultant_1; }, { nullable: true }),
        __metadata("design:type", UserConsultant)
    ], UserConsultant.prototype, "supervisor", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToMany(function (type) { return farmConsultant_type_1.FarmConsultant; }, function (farmConsultant) { return farmConsultant.userConsultant; }, { nullable: false }),
        __metadata("design:type", Array)
    ], UserConsultant.prototype, "farmConsultants", void 0);
    UserConsultant = UserConsultant_1 = __decorate([
        typeorm_1.Entity()
    ], UserConsultant);
    return UserConsultant;
}(basicR_type_1.BasicREntity));
exports.UserConsultant = UserConsultant;
//# sourceMappingURL=userConsultant.type.js.map