import { ValidationError } from 'class-validator';
export default class BusinessException extends Error {
    __proto__: Error;
    children: any;
    isPermission: boolean | undefined;
    constructor(message?: string, children?: any, isPermission?: boolean);
    static GENERAL: {
        NULL_VALUE: string;
        PERMISSION: string;
    };
    static AUTH: {
        INVALID_USERNAME: string;
        INVALID_PASSWORD: string;
    };
    static FARM_CONSULTANT: {
        FARM_CONSULTANTS_NOT_FOUND: string;
    };
    static CONTRACT: {
        DATEBIGGER: string;
        NEW_BEGINNING_SHIFT_ALL_AGREEMENTS: string;
        NO_REASON_SHIFT_AGREEMENTS: string;
        UPDATING_CONTRACT_WITH_DONE_VISITS: string;
        REMOVING_CONTRACT_WITH_DONE_VISITS: string;
    };
    static DAIRY: {
        MUST_HAVE_ADDRESS: string;
        DAIRY_COMPANY_NOT_FOUND: string;
    };
    static AGREEMENT: {
        DAIRY_INDUSTRY_AGREEMENT_MUST_HAVE_CONTRACT: string;
        AGREEMENT_INITIAL_DATE_BEFORE_CONTRACT_INITIAL_DATE: string;
        AGREEMENT_FINAL_DATE_AFTER_CONTRACT_FINAL_DATE: string;
        AGREEMENT_FINAL_DATE_PRIOR_TO_AGREEMENT_INITIAL_DATE: string;
        CONTRACT_NOT_FOUND: string;
        AGREEMENT_NOT_FOUND: string;
    };
    static FARM: {
        FARM_NOT_FOUND: string;
        MUST_HAVE_FARMER: string;
        MUST_HAVE_ADDRESS: string;
        SAVED_FARM_DOES_NOT_HAVE_FARMER_INTERNAL_ERROR: string;
        UPDATING_AGREEMENTS_MUST_BE_ARRAY: string;
        CREATING_AGREEMENTS_MUST_BE_ARRAY: string;
        DELETING_AGREEMENTS_MUST_BE_ARRAY: string;
        MULTIPLE_FARMS_WITH_SAME_ID: string;
    };
    static VISIT: {
        VISIT_DOES_NOT_EXIST: string;
        VISIT_ALREADY_MADE: string;
    };
    static CONSULTANT: {
        NO_IDENTIFICATION: string;
        NO_PHONE: string;
        NO_ADDRESS: string;
        ERROR_USER_INSERTION: string;
        FARM_NOT_FOUND: string;
        CONSULTANT_NOT_FOUND: string;
        CONSULTANT_WITH_FARM: string;
        NO_USER: string;
        PRIMARY_AND_ASSISTANT: string;
        PAYLOAD_MUST_HAVE_PRIMARYFARMS_ARRAY: string;
        PAYLOAD_MUST_HAVE_ASSISTANTFARMS_ARRAY: string;
        PAYLOAD_MUST_HAVE_SUPERVISED_ARRAY: string;
        PAYLOAD_MUST_HAVE_SUPERVISOR: string;
        PAYLOAD_MUST_SAY_IF_SUPERVISOR: string;
        PAYLOAD_MUST_INFORM_IF_SUPERVISOR: string;
        NON_SUPERVISOR_MUST_HAVE_SUPERVISOR: string;
        DUPLICATE_IDENTIFICATION: string;
        MUST_REASSIGN_SUPERVISED_BEFORE_SUPERVISOR_DELETION: string;
    };
    static FARMER: {
        FARMER_WITH_FARM: string;
        CANT_UPDATE_NON_EXISTENT: string;
        CANT_DELETE_NON_EXISTENT: string;
        FARMER_NOT_FOUND: string;
    };
    toJson(): ValidationError[];
}
