"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BusinessException = /** @class */ (function (_super) {
    __extends(BusinessException, _super);
    function BusinessException(message, children, isPermission) {
        var _newTarget = this.constructor;
        var _this = this;
        var trueProto = _newTarget.prototype;
        _this = _super.call(this, message) || this;
        // eslint-disable-next-line no-proto
        _this.__proto__ = trueProto;
        _this.children = children;
        _this.isPermission = isPermission;
        return _this;
    }
    BusinessException.prototype.toJson = function () {
        return [{
                constraints: {
                    code: this.message
                },
                property: '',
                children: this.children ? this.children : []
            }];
    };
    BusinessException.GENERAL = {
        NULL_VALUE: 'GENERAL_NULL_VALUE',
        PERMISSION: 'PERMISSION'
    };
    BusinessException.AUTH = {
        INVALID_USERNAME: 'AUTH_INVALID_USERNAME',
        INVALID_PASSWORD: 'AUTH_INVALID_PASSWORD'
    };
    BusinessException.FARM_CONSULTANT = {
        FARM_CONSULTANTS_NOT_FOUND: 'FARM_CONSULTANTS_NOT_FOUND'
    };
    BusinessException.CONTRACT = {
        DATEBIGGER: 'CONTRACT_DATEBIGGER',
        NEW_BEGINNING_SHIFT_ALL_AGREEMENTS: 'NEW_BEGINNING_SHIFT_ALL_AGREEMENTS',
        NO_REASON_SHIFT_AGREEMENTS: 'NO_REASON_SHIFT_AGREEMENTS',
        UPDATING_CONTRACT_WITH_DONE_VISITS: 'UPDATING_CONTRACT_WITH_DONE_VISITS',
        REMOVING_CONTRACT_WITH_DONE_VISITS: 'REMOVING_CONTRACT_WITH_DONE_VISITS'
    };
    BusinessException.DAIRY = {
        MUST_HAVE_ADDRESS: 'MUST_HAVE_ADDRESS',
        DAIRY_COMPANY_NOT_FOUND: 'DAIRY_COMPANY_NOT_FOUND'
    };
    BusinessException.AGREEMENT = {
        DAIRY_INDUSTRY_AGREEMENT_MUST_HAVE_CONTRACT: 'DAIRY_INDUSTRY_AGREEMENT_MUST_HAVE_CONTRACT',
        AGREEMENT_INITIAL_DATE_BEFORE_CONTRACT_INITIAL_DATE: 'AGREEMENT_INITIAL_DATE_BEFORE_CONTRACT_INITIAL_DATE',
        AGREEMENT_FINAL_DATE_AFTER_CONTRACT_FINAL_DATE: 'AGREEMENT_FINAL_DATE_AFTER_CONTRACT_FINAL_DATE',
        AGREEMENT_FINAL_DATE_PRIOR_TO_AGREEMENT_INITIAL_DATE: 'AGREEMENT_FINAL_DATE_PRIOR_TO_AGREEMENT_INITIAL_DATE',
        CONTRACT_NOT_FOUND: 'CONTRACT_NOT_FOUND',
        AGREEMENT_NOT_FOUND: 'AGREEMENT_NOT_FOUND'
    };
    BusinessException.FARM = {
        FARM_NOT_FOUND: 'FARM_NOT_FOUND',
        MUST_HAVE_FARMER: 'MUST_HAVE_FARMER',
        MUST_HAVE_ADDRESS: 'MUST_HAVE_ADDRESS',
        SAVED_FARM_DOES_NOT_HAVE_FARMER_INTERNAL_ERROR: 'SAVED_FARM_DOES_NOT_HAVE_FARMER_INTERNAL_ERROR',
        UPDATING_AGREEMENTS_MUST_BE_ARRAY: 'UPDATING_AGREEMENTS_MUST_BE_ARRAY',
        CREATING_AGREEMENTS_MUST_BE_ARRAY: 'CREATING_AGREEMENTS_MUST_BE_ARRAY',
        DELETING_AGREEMENTS_MUST_BE_ARRAY: 'DELETING_AGREEMENTS_MUST_BE_ARRAY',
        MULTIPLE_FARMS_WITH_SAME_ID: 'MULTIPLE_FARMS_WITH_SAME_ID'
    };
    BusinessException.VISIT = {
        VISIT_DOES_NOT_EXIST: 'VISIT_DOES_NOT_EXIST',
        VISIT_ALREADY_MADE: 'VISIT_ALREADY_MADE'
    };
    BusinessException.CONSULTANT = {
        NO_IDENTIFICATION: 'NO_IDENTIFICATION',
        NO_PHONE: 'NO_PHONE',
        NO_ADDRESS: 'NO_ADDRESS',
        ERROR_USER_INSERTION: 'ERROR_USER_INSERTION',
        FARM_NOT_FOUND: 'FARM_NOT_FOUND',
        CONSULTANT_NOT_FOUND: 'CONSULTANT_NOT_FOUND',
        CONSULTANT_WITH_FARM: 'CONSULTANT_WITH_FARM',
        NO_USER: 'NO_USER',
        PRIMARY_AND_ASSISTANT: 'PRIMARY_AND_ASSISTANT',
        PAYLOAD_MUST_HAVE_PRIMARYFARMS_ARRAY: 'PAYLOAD_MUST_HAVE_PRIMARYFARMS_ARRAY',
        PAYLOAD_MUST_HAVE_ASSISTANTFARMS_ARRAY: 'PAYLOAD_MUST_HAVE_ASSISTANTFARMS_ARRAY',
        PAYLOAD_MUST_HAVE_SUPERVISED_ARRAY: 'PAYLOAD_MUST_HAVE_SUPERVISED_ARRAY',
        PAYLOAD_MUST_HAVE_SUPERVISOR: 'PAYLOAD_MUST_HAVE_SUPERVISOR',
        PAYLOAD_MUST_SAY_IF_SUPERVISOR: 'PAYLOAD_MUST_SAY_IF_SUPERVISOR',
        PAYLOAD_MUST_INFORM_IF_SUPERVISOR: 'PAYLOAD_MUST_INFORM_IF_SUPERVISOR',
        NON_SUPERVISOR_MUST_HAVE_SUPERVISOR: 'NON_SUPERVISOR_MUST_HAVE_SUPERVISOR',
        DUPLICATE_IDENTIFICATION: 'DUPLICATE_IDENTIFICATION',
        MUST_REASSIGN_SUPERVISED_BEFORE_SUPERVISOR_DELETION: 'MUST_REASSIGN_SUPERVISED_BEFORE_SUPERVISOR_DELETION'
    };
    BusinessException.FARMER = {
        FARMER_WITH_FARM: 'FARMER_WITH_FARM',
        CANT_UPDATE_NON_EXISTENT: 'CANT_UPDATE_NON_EXISTENT',
        CANT_DELETE_NON_EXISTENT: 'CANT_DELETE_NON_EXISTENT',
        FARMER_NOT_FOUND: 'FARMER_NOT_FOUND'
    };
    return BusinessException;
}(Error));
exports.default = BusinessException;
//# sourceMappingURL=business.exception.js.map