/* eslint-disable no-unused-vars */
import { IsString, IsDefined } from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export enum ActionType {
  ALL = 'ALL',
  EDIT_PERMISSIONS = 'EDIT_PERMISSIONS',
  EDIT_USER_ACCESS = 'EDIT_USER_ACCESS',
  EDIT_PUBLICATIONS = 'EDIT_PUBLICATIONS',
  EDIT_NOTIFICATIONS = 'EDIT_NOTIFICATIONS',
  VIEW_DATA_FARMERS = 'VIEW_DATA_FARMERS',
  VIEW_DASHBOARD = 'VIEW_DASHBOARD'
  // ...
}

export class Permission extends BasicNREntity {
  @IsString()
  @IsDefined()
  name: string;

  @IsDefined()
  actions: ActionType[];

  // TODO: we can segment for cooperatives
}
