import { IsDefined, IsString, IsOptional, IsNumber } from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export class Property extends BasicNREntity {
  @IsString()
  @IsDefined()
  property: string;

  @IsNumber()
  @IsOptional()
  milking?: number;

  @IsNumber()
  @IsOptional()
  dry?: number;

  @IsString()
  @IsOptional()
  photoLink?: string;

  @IsString()
  @IsOptional()
  race?: string;

  @IsNumber()
  @IsOptional()
  latitude?: number;

  @IsNumber()
  @IsOptional()
  longitude?: number;

  photoBase64Content?: string;
}
