import {IsDefined, IsString, IsOptional, IsArray, IsMongoId} from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export class Document extends BasicNREntity {
  @IsString()
  @IsDefined()
  title: string;

  @IsString()
  @IsOptional()
  subtitle: string;

  @IsString()
  @IsOptional()
  edition: string;

  @IsString()
  @IsOptional()
  photoLink: string;

  @IsString()
  @IsOptional()
  link: string;

  // @IsArray()
  // @IsDefined()
  // categoryIds: string[];

  // @IsArray()
  // @IsOptional()
  // segmentations: Segmentation[];

  @IsDefined()
  @IsString()
  createdUserId: any;
}
