import { IsDefined, IsString, IsBoolean } from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export class Notification extends BasicNREntity {
  // Data comes from configuration

  @IsDefined()
  @IsString()
  headerTitle: string;

  @IsDefined()
  @IsString()
  headerText: string;

  @IsDefined()
  @IsBoolean()
  push: boolean;

  @IsDefined()
  @IsBoolean()
  alert: boolean;
}
