import { IsArray, IsDefined, IsString, IsOptional, IsMongoId } from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export class Post extends BasicNREntity {
  @IsArray()
  @IsOptional()
  usersRead: string[];

  @IsOptional()
  @IsString()
  mainImageId?: string;

  @IsDefined()
  @IsString()
  headerTitle: string;

  @IsDefined()
  @IsString()
  headerText: string;

  @IsArray()
  @IsDefined()
  categoryIds: string[];

  @IsArray()
  @IsOptional()
  tags?: string[];

  @IsString()
  @IsOptional()
  youtubeLink?: string;

  @IsArray()
  @IsOptional()
  imagesIds?: string[];

  @IsArray()
  @IsOptional()
  likedUserIds?: string[];

  // @IsArray()
  // @IsOptional()
  // segmentations: Segmentation[];

  @IsDefined()
  @IsString()
  createdUserId: any;

  photoBase64Content?: string;
}
