import { IsNotEmpty, IsString, IsOptional, IsNumber } from 'class-validator';
import { Column, Entity, ManyToOne } from 'typeorm';
import { BasicREntity } from '../../basicR.type';
import { OtherExpenseSubCategory } from './otherExpenseSubcategory.type';

@Entity()
export class OtherExpenseItem extends BasicREntity {
  
  @IsNotEmpty()
  @IsString()
  @Column({ nullable: false })
  name: String;

  @IsNotEmpty()
  @ManyToOne(type=>OtherExpenseSubCategory)
  otherExpenseSubCategory:OtherExpenseSubCategory

  @IsOptional()
  @IsNumber()
  @Column()
  quantity:Number;

  @IsOptional()
  @IsNumber()
  @Column()
  unitaryValue:Number;

}