import { Entity, Column, JoinColumn, PrimaryGeneratedColumn, OneToOne, OneToMany, ManyToOne } from 'typeorm';
import { BasicREntity } from '../../basicR.type';
import { IsNumber, IsDate, IsNotEmpty } from 'class-validator';
import { Farm } from '../../visit/farm.type'
import { RoutineExpense } from '../../..';

@Entity()
export class RoutineExpenseItem extends BasicREntity {
  
  @IsNotEmpty()
  @IsDate()
  @Column({ nullable: false })
  date: Date;

  @IsNotEmpty()
  @ManyToOne(type => RoutineExpense)
  routineExpense: RoutineExpense;

  @IsNotEmpty()
  @Column()
  @IsNumber()
  value:Number;

}