import { IsDate, IsString, IsNotEmpty, IsNumber } from 'class-validator';
import { Column, Entity, IsNull } from 'typeorm';
import { BasicREntity } from '../../basicR.type';
import { InventoryAreaPastureType } from './inventoryArea.type';

@Entity()
export class InventoryAreaPastureSpec extends BasicREntity {

    @IsNotEmpty()
    @IsDate()
    @Column()
    lifeSpan:Date;

    @IsNotEmpty()
    @IsNumber()
    @Column()
    type:InventoryAreaPastureType;

    @IsNotEmpty()
    @IsNumber()
    @Column()
    value:Number


}