import { IsDate, IsNumber, IsString, IsNotEmpty } from 'class-validator';
import { Column, Entity, ManyToOne } from 'typeorm';
import { BasicREntity } from '../../basicR.type';
import { Farm } from '../../visit/farm.type';

export enum InventoryImprovementType{
    TYPE_ONE,
    TYPE_TWO,
    TYPE_THREE,
    TYPE_FOUR,
    TYPE_FIVE,
    TYPE_SIX,
    PICKET_FENCE,
    INTERNAL_FENCE,
    PERIMETER_FENCE
}

@Entity()
export class InventoryImprovement extends BasicREntity {

    @IsNotEmpty()
    @IsDate()
    @Column({ nullable: false })
    constructionDate: Date;

    @IsNotEmpty()
    @IsDate()
    @Column({ nullable: false })
    lifeSpan: Date;

    @IsNotEmpty()
    @IsNumber()
    @Column({ nullable: false })
    value: Number;

    @IsNotEmpty()
    @IsString()
    @Column({ nullable: false })
    name: string;

    @IsNotEmpty()
    @IsNumber()
    @Column({ type: 'int' })
    type:InventoryImprovementType;
    
    @IsNotEmpty()
    @IsNumber()
    @Column()
    size:Number;

    @IsNotEmpty()
    @ManyToOne(type=>Farm)
    farm:Farm;
}