import { IsDate, IsNumber, IsString, IsNotEmpty } from 'class-validator';
import { Column, Entity, ManyToOne } from 'typeorm';
import { BasicREntity } from '../../basicR.type';
import { InventoryImprovementType } from './inventoryImprovement.type';

@Entity()
export class InventoryImprovementSpec extends BasicREntity {

    @IsNotEmpty()
    @IsDate()
    @Column({ nullable: false })
    lifeSpan: Date;

    @IsNotEmpty()
    @IsNumber()
    @Column({ nullable: false })
    value: Number;

    @IsNotEmpty()
    @IsString()
    @Column({ nullable: false })
    name: string;

    @IsNotEmpty()
    @IsNumber()
    @Column({ nullable: false,type:'int' })
    type:InventoryImprovementType

}