import { IsDate, IsNumber, IsString, IsNotEmpty } from 'class-validator';
import { Column, Entity, ManyToOne, OneToOne, JoinColumn } from 'typeorm';
import { BasicREntity } from '../../basicR.type';
import { Farm } from '../../visit/farm.type';

export enum InventoryItemCategory{
  OTHER,
  AREA,
  MACHINERY,
}

@Entity()
export class InventoryItem extends BasicREntity {
  
  @IsNotEmpty()
  @IsDate()
  @Column({ nullable: false })
  date: Date;

  @IsNotEmpty()
  @ManyToOne(type => Farm, farm => farm.inventoryItems, { nullable: false })
  farm: Farm

  @IsNotEmpty()
  @IsString()
  @Column({ nullable: false })
  name: string;

  @IsNotEmpty()
  @IsNumber()
  @Column({ nullable: false, type: 'int' })
  category: InventoryItemCategory;
}