import { IsDate, IsNumber, IsString, IsNotEmpty } from 'class-validator';
import { Column, Entity, ManyToOne } from 'typeorm';
import { BasicREntity } from '../../basicR.type';
import { Farm } from '../../visit/farm.type';

export enum InventoryMachineryType{
    SMALL,
    MEDIUM,
    BIG
}

@Entity()
export class InventoryMachinery extends BasicREntity {

    @IsNotEmpty()
    @IsDate()
    @Column({ nullable: false })
    acquisitionDate: Date;

    @IsNotEmpty()
    @IsString()
    @Column({ nullable: false })
    name: string;

    @IsNotEmpty()
    @IsNumber()
    @Column({ type: 'int' })
    type:InventoryMachineryType;
    
    @IsNotEmpty()
    @IsNumber()
    @Column()
    value:Number;

    @IsNotEmpty()
    @IsDate()
    @Column()
    lifeSpan:Date;

    @IsNotEmpty()
    @ManyToOne(type=>Farm)
    farm:Farm;

}