import { IsDate, IsNumber, IsString, IsNotEmpty } from 'class-validator';
import { Column, Entity, ManyToOne } from 'typeorm';
import { BasicREntity } from '../../basicR.type';
import { InventoryMachineryType } from './inventoryMachinery.type';


@Entity()
export class InventoryMachinerySpec extends BasicREntity {

    @IsNotEmpty()
    @IsNumber()
    @Column({ type: 'int' })
    type:InventoryMachineryType;
    
    @IsNotEmpty()
    @IsNumber()
    @Column()
    lifeSpan:Number;

}