import { Column, Entity, OneToMany, OneToOne, ManyToMany, ManyToOne } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { Installment } from './expense/installment.type';
import { Revenue } from './revenue.type';
import { IsNotEmpty, IsString, IsNumber, IsDate, IsBoolean } from 'class-validator';
import { Farm } from '../visit/farm.type';

export enum InvestmentOrderCategory{
    PASTURE_FORMATION,
    IMPROVEMENT
}

@Entity()
export class InvestmentOrder extends BasicREntity {

    @IsNotEmpty()
    @IsString()
    @Column()
    name:String;
    
    @IsNotEmpty()
    @IsNumber()
    @Column({type:'int'})
    type:InvestmentOrderCategory;

    @IsNotEmpty()
    @IsDate()
    @Column()
    date:Date;

    @IsNotEmpty()
    @IsBoolean()
    @Column()
    open:Boolean;

    @IsNotEmpty()
    @ManyToOne(type=>Farm)
    farm:Farm;


}