import { IsDate, IsBoolean, IsNumber, IsNotEmpty } from 'class-validator';
import { Column, Entity, ManyToOne, IsNull, OneToOne, JoinColumn, OneToMany } from 'typeorm';
import { Farm } from '../../visit/farm.type';
import { BasicREntity } from '../../basicR.type';
import { Loan } from './loan.type';
import { DairyCompany } from '../../visit/dairyCompany.type';

export enum MilkInternalSpendingCategory {
    CATTLE_MILKING=1,
    INTERNAL_CONSUMPTION=2,
    DISCARDED=3
  }


@Entity()
export class MilkInternalSpending extends BasicREntity {
  
  @IsNotEmpty()
  @IsDate()
  @Column({ nullable: false })
  date: Date;

  @IsNotEmpty()
  @ManyToOne(type => Farm, farm => farm.milkInternalSpendings, { nullable: false })
  farm: Farm;
  
  @IsNotEmpty()
  @IsNumber()
  liters:Number;
  
  @IsNotEmpty()
  @IsNumber()
  pricePerLiter:Number;

  @IsNotEmpty()
  @IsNumber()
  @Column({ nullable: false, type: 'int' })
  milkInternalSpendingCategory:MilkInternalSpendingCategory

 }