import { IsDate, IsBoolean, IsNumber, IsNotEmpty } from 'class-validator';
import { Column, Entity, ManyToOne, IsNull, OneToOne, JoinColumn, OneToMany } from 'typeorm';
import { Farm } from '../../visit/farm.type';
import { BasicREntity } from '../../basicR.type';
import { Loan } from './loan.type';
import { DairyCompany } from '../../visit/dairyCompany.type';

@Entity()
export class MilkRevenue extends BasicREntity {
  
  @IsNotEmpty()
  @IsDate()
  @Column({ nullable: false })
  date: Date;

  @IsNotEmpty()
  @ManyToOne(type => Farm, farm => farm.milkRevenues, { nullable: false })
  farm: Farm;
  
  @IsNotEmpty()
  @IsNumber()
  liters:Number;
  
  @IsNotEmpty()
  @IsNumber()
  pricePerLiter:Number;

  @IsNotEmpty()
  @ManyToOne(type => DairyCompany, { nullable: false })
  dairyCompany: DairyCompany

 }