import { IsDefined, IsDate, IsString, IsOptional, IsNumber } from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export class Collect extends BasicNREntity {
  @IsDate()
  @IsDefined()
  date: Date;

  @IsString()
  property: string;

  @IsString()
  @IsOptional()
  trip: string;

  @IsString()
  @IsOptional()
  route: string;

  @IsString()
  @IsOptional()
  transp: string;

  @IsString()
  @IsOptional()
  driver: string;

  @IsString()
  @IsOptional()
  sample: string;

  @IsString()
  @IsOptional()
  compartment: string;

  @IsNumber()
  @IsOptional()
  volume: number;

  @IsNumber()
  @IsOptional()
  rule: number;

  @IsNumber()
  @IsOptional()
  temperature: number;
}
