import { IsString, IsDefined, IsNumber } from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export class QualityConsolidated extends BasicNREntity {
    @IsString()
    @IsDefined()
  property: string; // Produtor

    @IsDefined()
    @IsNumber()
    month: number;

    @IsDefined()
    @IsNumber()
    year: number;

    @IsNumber()
    referenceSCC: number;

    @IsNumber()
    cooperativeAverageSCC: number;

    @IsNumber()
    billingSCC: number;

    @IsNumber()
    referenceTBC: number;

    @IsNumber()
    cooperativeAverageTBC: number;

    @IsNumber()
    billingTBC: number;

    @IsNumber()
    referenceFat: number;

    @IsNumber()
    cooperativeAverageFat: number;

    @IsNumber()
    billingFat: number;

    @IsNumber()
    referenceProtein: number;

    @IsNumber()
    cooperativeAverageProtein: number;

    @IsNumber()
    billingProtein: number;
}
