import { IsDefined, IsDate, IsString, IsOptional, IsNumber } from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export class Invoice extends BasicNREntity {
  @IsDate()
  @IsDefined()
  date: Date;

  @IsString()
  @IsDefined()
  property: string;

  @IsString()
  additional_market: string;
  
  @IsString()
  animal_health_rate: string;
  
  @IsString()
  base_icms: string;
  
  @IsString()
  bonus_logistic: string;
  
  @IsString()
  bonus_loyalty: string;
  
  @IsString()
  bonus_protein: string;
  
  @IsString()
  bonus_scale: string;
  
  @IsString()
  complement_price: string;
  
  @IsString()
  incentive_production: string;
  
  @IsString()
  inss: string;
  
  @IsString()
  milk_cru: string;
  
  @IsString()
  rat: string;
  
  @IsString()
  senar: string;
  
  @IsString()
  total_credits: string;
  
  @IsString()
  total_debts: string;
  
  @IsString()
  value: string;

  @IsString()
  value_deposit: string;
  
  @IsString()
  value_icms: string;
  
  @IsString()
  value_total_bill: string;
  
  @IsString()
  value_total_product: string;
}
