import { IsString, IsDefined, IsOptional, IsArray } from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export class PropertyData extends BasicNREntity {
  @IsString()
  @IsDefined()
  name: string;

  @IsString()
  @IsOptional()
  propertyCode: string;

  @IsString()
  @IsOptional()
  segLevel1?: string; // Cooperativa

  @IsString()
  @IsOptional()
  segLevel2?: string; // Matricula

  @IsString()
  @IsOptional()
  segLevel3?: string; // Linha

  @IsString()
  @IsOptional()
  city: string;

  @IsString()
  @IsOptional()
  state: string;

  @IsString()
  @IsOptional()
  race?: string;

  @IsOptional()
  @IsArray()
  coordinators?: string[];

  @IsOptional()
  @IsArray()
  supervisores?: string[];

  @IsOptional()
  @IsArray()
  producers?: string[];

  @IsString()
  @IsOptional()
  situation?: string;
}
