import { IsDefined, IsDate, IsString, IsNumber, IsOptional } from 'class-validator';
import { BasicNREntity } from '../basicNR.type';

export class Quality extends BasicNREntity {
  @IsDate()
  @IsDefined()
  date: Date; // Dt.Result

  @IsString()
  @IsOptional()
  section_name: string; // Nome Setor

  @IsString()
  @IsOptional()
  section_code: string; // Cod.Setor

  @IsString()
  @IsDefined()
  property: string; // Produtor

  @IsString()
  @IsOptional()
  reception: string; // Nome Recepção

  @IsString()
  @IsOptional()
  reception_code: string; // Cod.Recepção

  @IsNumber()
  @IsOptional()
  Sample1: number; // Amostra1

  @IsNumber()
  @IsOptional()
  CQAm1: number; // CQAm1

  @IsNumber()
  @IsOptional()
  fat: number; // Gordura

  @IsNumber()
  @IsOptional()
  protein: number; // Proteina

  @IsNumber()
  @IsOptional()
  lactose: number; // Lactose

  @IsNumber()
  @IsOptional()
  tbc: number; // CBT - Sólidos

  @IsNumber()
  @IsOptional()
  scc: number; // CCS

  @IsNumber()
  @IsOptional()
  ESD: number; // ESD

  @IsNumber()
  @IsOptional()
  sample2: number; // Amostra2

  @IsNumber()
  @IsOptional()
  CQAm2: number; // CQAm2

  @IsNumber()
  @IsOptional()
  UFC_Curva: number; // UFC Curva

  @IsNumber()
  @IsOptional()
  CQAm3: number; // CQAm3

  @IsNumber()
  @IsOptional()
  crioscopy: number; // Crioscopia

  @IsNumber()
  @IsOptional()
  protocol: number; // Protocolo

  @IsNumber()
  @IsOptional()
  Criosc: number; // Criosc

  @IsNumber()
  @IsOptional()
  casein: number; // Caseina

  @IsNumber()
  @IsOptional()
  urea: number; // Ureia
}
