import { Farm } from './farm.type';
import { Entity, Column, JoinColumn, PrimaryGeneratedColumn, OneToMany, ManyToOne, OneToOne, ManyToMany } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { IsNumber, IsNotEmpty, IsOptional, IsArray, IsString, IsBoolean } from 'class-validator';
import { UserConsultant } from './userConsultant.type';
import { UserFarmer } from './userFarmer.type';

// export enum FarmRole {
//     OWNER = 1,
//     WORKER = 2
// }

@Entity()
export class FarmFarmer extends BasicREntity {

    // @IsOptional()
    // @IsNumber()
    // @Column({ nullable: false, type: 'int' })
    // role: FarmRole;

    @IsNotEmpty()
    @ManyToOne(type => Farm, farm => farm.farmFarmers, { nullable: false })
    farm: Farm;

    @IsNotEmpty()
    @ManyToOne(type => UserFarmer, userFarmer => userFarmer.farmFarmers, { nullable: false })
    userFarmer: UserFarmer;

}