import { FarmFarmer } from './farmFarmer.type';
import { Address } from '../app/address.type';
import { Entity, Column, JoinColumn, PrimaryGeneratedColumn, OneToMany, ManyToOne, OneToOne, ManyToMany } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { IsString, IsNotEmpty, IsOptional, IsArray } from 'class-validator';
import { Farm } from './farm.type';

@Entity()
export class UserFarmer extends BasicREntity {

    @IsString()
    @IsNotEmpty()
    @Column({ nullable: false })
    name: string;

    @IsString()
    @IsNotEmpty()
    @Column({ nullable: false })
    emails: string;

    @IsString()
    @IsOptional()
    @Column({ nullable: true })
    linkPhoto?: string;

    @IsString()
    @IsNotEmpty()
    @Column({ nullable: false })
    phones: string;

    @IsString()
    @IsNotEmpty()
    @Column({ nullable: false })
    identification: String;

    @JoinColumn()
    @IsNotEmpty()
    @OneToOne(type => Address, { cascade: true, nullable: false })
    address?: Address;

    @IsOptional()
    @OneToMany(type => FarmFarmer, farmFarmer => farmFarmer.userFarmer)
    farmFarmers?: FarmFarmer[];
}