import { ValidationError } from 'class-validator';
export default class BusinessException extends Error {
  __proto__: Error;

  children: any;

  isPermission: boolean | undefined;

  constructor(message?: string, children?: any, isPermission? : boolean) {
    const trueProto = new.target.prototype;
    super(message);
    // eslint-disable-next-line no-proto
    this.__proto__ = trueProto;
    this.children = children;
    this.isPermission = isPermission;
  }

  public static GENERAL = {
    NULL_VALUE: 'GENERAL_NULL_VALUE',
    PERMISSION: 'PERMISSION'
  };

  public static AUTH = {
    INVALID_USERNAME: 'AUTH_INVALID_USERNAME',
    INVALID_PASSWORD: 'AUTH_INVALID_PASSWORD'
  };

  public static FARM_CONSULTANT = {
    FARM_CONSULTANTS_NOT_FOUND: 'FARM_CONSULTANTS_NOT_FOUND'
  };

  public static CONTRACT = {
    DATEBIGGER: 'CONTRACT_DATEBIGGER',
    NEW_BEGINNING_SHIFT_ALL_AGREEMENTS: 'NEW_BEGINNING_SHIFT_ALL_AGREEMENTS',
    NO_REASON_SHIFT_AGREEMENTS: 'NO_REASON_SHIFT_AGREEMENTS',
    UPDATING_CONTRACT_WITH_DONE_VISITS: 'UPDATING_CONTRACT_WITH_DONE_VISITS',
    REMOVING_CONTRACT_WITH_DONE_VISITS: 'REMOVING_CONTRACT_WITH_DONE_VISITS'
  };

  public static DAIRY = {
    MUST_HAVE_ADDRESS: 'MUST_HAVE_ADDRESS',
    DAIRY_COMPANY_NOT_FOUND: 'DAIRY_COMPANY_NOT_FOUND'
  };

  public static AGREEMENT ={
    DAIRY_INDUSTRY_AGREEMENT_MUST_HAVE_CONTRACT: 'DAIRY_INDUSTRY_AGREEMENT_MUST_HAVE_CONTRACT',
    AGREEMENT_INITIAL_DATE_BEFORE_CONTRACT_INITIAL_DATE: 'AGREEMENT_INITIAL_DATE_BEFORE_CONTRACT_INITIAL_DATE',
    AGREEMENT_FINAL_DATE_AFTER_CONTRACT_FINAL_DATE: 'AGREEMENT_FINAL_DATE_AFTER_CONTRACT_FINAL_DATE',
    AGREEMENT_FINAL_DATE_PRIOR_TO_AGREEMENT_INITIAL_DATE: 'AGREEMENT_FINAL_DATE_PRIOR_TO_AGREEMENT_INITIAL_DATE',
    CONTRACT_NOT_FOUND: 'CONTRACT_NOT_FOUND',
    AGREEMENT_NOT_FOUND: 'AGREEMENT_NOT_FOUND'
  };

  public static FARM = {
    FARM_NOT_FOUND: 'FARM_NOT_FOUND',
    MUST_HAVE_FARMER: 'MUST_HAVE_FARMER',
    MUST_HAVE_ADDRESS: 'MUST_HAVE_ADDRESS',
    SAVED_FARM_DOES_NOT_HAVE_FARMER_INTERNAL_ERROR: 'SAVED_FARM_DOES_NOT_HAVE_FARMER_INTERNAL_ERROR',
    UPDATING_AGREEMENTS_MUST_BE_ARRAY: 'UPDATING_AGREEMENTS_MUST_BE_ARRAY',
    CREATING_AGREEMENTS_MUST_BE_ARRAY: 'CREATING_AGREEMENTS_MUST_BE_ARRAY',
    DELETING_AGREEMENTS_MUST_BE_ARRAY: 'DELETING_AGREEMENTS_MUST_BE_ARRAY',
    MULTIPLE_FARMS_WITH_SAME_ID: 'MULTIPLE_FARMS_WITH_SAME_ID'
  };

  public static VISIT = {
    VISIT_DOES_NOT_EXIST: 'VISIT_DOES_NOT_EXIST',
    VISIT_ALREADY_MADE: 'VISIT_ALREADY_MADE'
  };

  public static CONSULTANT = {
    NO_IDENTIFICATION: 'NO_IDENTIFICATION',
    NO_PHONE: 'NO_PHONE',
    NO_ADDRESS: 'NO_ADDRESS',
    ERROR_USER_INSERTION: 'ERROR_USER_INSERTION',
    FARM_NOT_FOUND: 'FARM_NOT_FOUND',
    CONSULTANT_NOT_FOUND: 'CONSULTANT_NOT_FOUND',
    CONSULTANT_WITH_FARM: 'CONSULTANT_WITH_FARM',
    NO_USER: 'NO_USER',
    PRIMARY_AND_ASSISTANT: 'PRIMARY_AND_ASSISTANT',
    PAYLOAD_MUST_HAVE_PRIMARYFARMS_ARRAY: 'PAYLOAD_MUST_HAVE_PRIMARYFARMS_ARRAY',
    PAYLOAD_MUST_HAVE_ASSISTANTFARMS_ARRAY: 'PAYLOAD_MUST_HAVE_ASSISTANTFARMS_ARRAY',
    PAYLOAD_MUST_HAVE_SUPERVISED_ARRAY: 'PAYLOAD_MUST_HAVE_SUPERVISED_ARRAY',
    PAYLOAD_MUST_HAVE_SUPERVISOR: 'PAYLOAD_MUST_HAVE_SUPERVISOR',
    PAYLOAD_MUST_SAY_IF_SUPERVISOR: 'PAYLOAD_MUST_SAY_IF_SUPERVISOR',
    PAYLOAD_MUST_INFORM_IF_SUPERVISOR: 'PAYLOAD_MUST_INFORM_IF_SUPERVISOR',
    NON_SUPERVISOR_MUST_HAVE_SUPERVISOR: 'NON_SUPERVISOR_MUST_HAVE_SUPERVISOR',
    DUPLICATE_IDENTIFICATION: 'DUPLICATE_IDENTIFICATION',
    MUST_REASSIGN_SUPERVISED_BEFORE_SUPERVISOR_DELETION: 'MUST_REASSIGN_SUPERVISED_BEFORE_SUPERVISOR_DELETION'
  };

  public static FARMER = {
    FARMER_WITH_FARM: 'FARMER_WITH_FARM',
    CANT_UPDATE_NON_EXISTENT: 'CANT_UPDATE_NON_EXISTENT',
    CANT_DELETE_NON_EXISTENT: 'CANT_DELETE_NON_EXISTENT',
    FARMER_NOT_FOUND: 'FARMER_NOT_FOUND'
  };

  public toJson() {
    return [<ValidationError>{
      constraints: {
        code: this.message
      },
      property: '',
      children: this.children ? this.children : []
    }];
  }
}
